/*
 *	Initialise the memory management. For now simply print the amount of
 *	memory!
 */
 
#include <linuxmt/types.h>
#include <linuxmt/config.h>
#include <arch/segment.h>

/*
 *	0x9000:2	- Extended memory size
 *	0x9000:4	- Display page
 *	0x9000:6	- Video mode
 *	0x9000:7	- Window Width
 *	0x9000:8,10,12	- Video parameters
 *	0x9000:15 	- No vga
 *	0x9000:16	- Video height (points)
 *
 *	0x9000:80	- 16 bytes of disk 0 info
 *	0x9000:90	- 16 bytes of disk 1 info
 *
 *	1ff		- AA if psmouse present
 */

/*
 *	These belong in something like mm/segment.c when we create it.
 */ 
#asm
_get_ds:
	mov 	ax,ds
	ret
_get_cs:
	mov	ax,cs
	ret
_get_es:
	mov	ax,es
	ret
_get_ss:
	mov	ax,ss
	ret
#endasm

void setup_mm()
{
	int basemem=640;		/* Hard coded */
	int xms=peekw(0x9000,2);	/* Fetched by boot code */
	printk("%dK base", basemem);
	if(xms)
		printk(", %dK extended");
	printk(".\n");
	printk("ELKS kernel (%d text + %d data + %d bss)\n",
		(int)_endtext, (int)_enddata, (int)_endbss-(int)_enddata);
	printk("Kernel text at %x:0000, data at %x:0000 \n", get_cs(),
		get_ds());
	if(peekb(0x9000,0x1ff)==0xAA)
		printk("ps2: PS/2 pointing device detected\n");
}
