#include <linuxmt/types.h>
#include <linuxmt/config.h>
#include <linuxmt/sched.h>
#include <linuxmt/errno.h>


struct hd_info
{
	unsigned short cyl;
	unsigned short wpcom;
	unsigned short lzone;
	unsigned char head;
	unsigned char sect;
	unsigned char ctl;
};

static struct hd_info disks[2];

void hd_init()
{
	int d=0;
	int pos=0x80;	/* Disk base */
	unsigned long size;
	for(d=0;d<2;d++)
	{
		disks[d].cyl	=	peekw(0x9000,pos);
		disks[d].head	=	peekb(0x9000,pos+2);
		disks[d].wpcom	=	peekw(0x9000,pos+5);
		disks[d].ctl	=	peekb(0x9000,pos+8);
		disks[d].lzone	=	peekw(0x9000,pos+12);
		disks[d].sect	=	peekb(0x9000,pos+14);
		pos+=16;
		if(disks[d].cyl)
		{
			/* Size in .5K blocks */
			size=disks[d].head*disks[d].cyl*disks[d].sect;
			/* Convert to Mb */
			size/=2048;
			printk("hd%c: %d heads %d cylinders, %d sectors (%ldMb).\n",
				d+'a',disks[d].head,disks[d].cyl,disks[d].sect, size);
		}
		
	};
}	
