#ifndef LINUXMT_SCHED_H
#define LINUXMT_SCHED_H

#define MAX_TASKS 32

struct task_struct 
{
/* Executive stuff */
	__registers t_regs;
	__uint t_num;
	__pptr t_begcode, t_endcode, t_begdata, t_enddata, t_begstack, t_endstack; 
/* Kernel info */
	pid_t pid,ppid;
	pid_t session;
	uid_t uid,euid,suid;
	gid_t gid,egid,sgid;	
/* Scheduling + status variables */
	__s16 state;
	__uint t_count, t_priority;	/* Valuable scheduling elements */
	__u16 t_flags; 		/* Not defined yet */
	__u8  t_kstack[128];	/* Kernel stack (128bytes) */
};

#define TASK_RUNNING 		0
#define TASK_INTERRUPTIBLE	1
#define TASK_UNINTERRUPTIBLE 	2
#define TASK_ZOMBIE		3
#define TASK_STOPPED		4
#define TASK_SWAPPING		5
#define TASK_UNUSED		6



/* We use typedefs to avoid using struct foobar (*) */
typedef struct task_struct __task;
typedef struct task_struct * __ptask;

__task task[MAX_TASKS];

extern __ptask current, next;
extern __uint curnum;

_FUNCTION(__uint build_task, ());
_FUNCTION(__uint alloc_task, (__ptask ptask));
_FUNCTION(void schedule, ()); 

#endif
