/*
 * 	kernel/sched.c
 * 	(C) 1995 Chad Page 
 *	
 *	This is the main scheduler - hopefully simpler than Linux's at present.
 * 
 * 	We need to implement run-queues RSN, but first we just have to make
 * 	it *work*.  Of course, writing it would be a good start :)
 *
 */

#include <linuxmt/types.h>
#include <linuxmt/sched.h>

__ptask current, next;
__uint curnum;

/*
 *	Schedule a task. On entry current is the task, which will
 *	vanish quietly for a while and someone elses thread will return
 *	from here.
 */
 
void schedule()
{
	__uint maxpri; 
	__uint c, maxproc; 
	__ptask pt; 	/* Subscipt calculation is *very* expensive in bcc */

	curnum = 0;

	maxproc = maxpri = 0;
	for (c = 0; c < MAX_TASKS; c++) 
	{
		pt = &task[c];
		if (pt->state == TASK_RUNNING) 
		{
			pt->t_count += pt->t_priority;
			if (pt->t_count > maxpri) 
			{
				maxproc = c;
				maxpri = pt->t_count;
			}
		}
	}

	task[maxproc].t_count = 0;
	curnum = maxproc;
	if (&task[curnum] != current) 
	{
		save_regs(current);
		current = &task[curnum];
		load_regs(current);	/* Returns to our caller */
	}
}

